<html>
<head>
<title>OgreHardwareBufferManager.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreHardwareBufferManager.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreHardwareBufferManager_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __HardwareBufferManager__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __HardwareBufferManager__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// Precompiler options</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreSingleton_8h.html">OgreSingleton.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareVertexBuffer_8h.html">OgreHardwareVertexBuffer.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreHardwareIndexBuffer_8h.html">OgreHardwareIndexBuffer.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderToVertexBuffer_8h.html">OgreRenderToVertexBuffer.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Ogre {
<a name="l00057"></a><a class="code" href="classOgre_1_1HardwareBufferLicensee.html">00057</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1HardwareBufferLicensee.html" title="Abstract interface representing a &#39;licensee&#39; of a hardware buffer copy.">HardwareBufferLicensee</a>
<a name="l00058"></a>00058     {
<a name="l00059"></a>00059     <span class="keyword">public</span>:
<a name="l00060"></a><a class="code" href="classOgre_1_1HardwareBufferLicensee.html#a5d0010fd36b460b1c0c2a4ba4337aea5">00060</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1HardwareBufferLicensee.html#a5d0010fd36b460b1c0c2a4ba4337aea5">~HardwareBufferLicensee</a>() { }
<a name="l00063"></a>00063         <span class="keyword">virtual</span> <span class="keywordtype">void</span> licenseExpired(<a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>* buffer) = 0;
<a name="l00064"></a>00064     };
<a name="l00065"></a>00065 
<a name="l00067"></a><a class="code" href="classOgre_1_1TempBlendedBufferInfo.html">00067</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1TempBlendedBufferInfo.html" title="Structure for recording the use of temporary blend buffers.">TempBlendedBufferInfo</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1HardwareBufferLicensee.html" title="Abstract interface representing a &#39;licensee&#39; of a hardware buffer copy.">HardwareBufferLicensee</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">BufferAlloc</a>
<a name="l00068"></a>00068     {
<a name="l00069"></a>00069     <span class="keyword">private</span>:
<a name="l00070"></a>00070         <span class="comment">// Pre-blended </span>
<a name="l00071"></a><a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#aba9a78063ebade2611b1b7fb86556269">00071</a>         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> <a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#aba9a78063ebade2611b1b7fb86556269">srcPositionBuffer</a>;
<a name="l00072"></a><a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#a04f81935036ade45ee9b27076cdbff1f">00072</a>         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> <a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#a04f81935036ade45ee9b27076cdbff1f">srcNormalBuffer</a>;
<a name="l00073"></a>00073         <span class="comment">// Post-blended </span>
<a name="l00074"></a><a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#a51ba46f5674027983a641c8f5919ed5a">00074</a>         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> <a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#a51ba46f5674027983a641c8f5919ed5a">destPositionBuffer</a>;
<a name="l00075"></a><a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#a098debe872ac4c67507daf401e25727a">00075</a>         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> <a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#a098debe872ac4c67507daf401e25727a">destNormalBuffer</a>;
<a name="l00077"></a><a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#a4177ac660c67a59428bfe77c71fd1cc7">00077</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#a4177ac660c67a59428bfe77c71fd1cc7" title="Both positions and normals are contained in the same buffer.">posNormalShareBuffer</a>;
<a name="l00078"></a><a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#a204cdbf159d8375a2cca3ed58c34d317">00078</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#a204cdbf159d8375a2cca3ed58c34d317">posBindIndex</a>;
<a name="l00079"></a><a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#a0b4e2a46911fe4a6191010ec584ec744">00079</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#a0b4e2a46911fe4a6191010ec584ec744">normBindIndex</a>;
<a name="l00080"></a><a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#ae52a9468dca74ba1306c1f8d3bcf41fc">00080</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#ae52a9468dca74ba1306c1f8d3bcf41fc">bindPositions</a>;
<a name="l00081"></a><a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#ad304cea26a4e551969a63c13012cec59">00081</a>         <span class="keywordtype">bool</span> <a class="code" href="classOgre_1_1TempBlendedBufferInfo.html#ad304cea26a4e551969a63c13012cec59">bindNormals</a>;
<a name="l00082"></a>00082 
<a name="l00083"></a>00083     <span class="keyword">public</span>:
<a name="l00084"></a>00084         ~<a class="code" href="classOgre_1_1TempBlendedBufferInfo.html" title="Structure for recording the use of temporary blend buffers.">TempBlendedBufferInfo</a>(<span class="keywordtype">void</span>);
<a name="l00086"></a>00086         <span class="keywordtype">void</span> extractFrom(<span class="keyword">const</span> <a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* sourceData);
<a name="l00088"></a>00088         <span class="keywordtype">void</span> checkoutTempCopies(<span class="keywordtype">bool</span> positions = <span class="keyword">true</span>, <span class="keywordtype">bool</span> normals = <span class="keyword">true</span>);
<a name="l00090"></a>00090         <span class="keywordtype">void</span> bindTempCopies(<a class="code" href="classOgre_1_1VertexData.html" title="Summary class collecting together vertex source information.">VertexData</a>* targetData, <span class="keywordtype">bool</span> suppressHardwareUpload);
<a name="l00092"></a>00092         <span class="keywordtype">void</span> licenseExpired(<a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>* buffer);
<a name="l00094"></a>00094         <span class="keywordtype">bool</span> buffersCheckedOut(<span class="keywordtype">bool</span> positions = <span class="keyword">true</span>, <span class="keywordtype">bool</span> normals = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00095"></a>00095     };
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00109"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html">00109</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator...">BufferAlloc</a>
<a name="l00110"></a>00110     {
<a name="l00111"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#abdb4b01e9cf06263b1bae7fbb0bb2e9e">00111</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>;
<a name="l00112"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ac301d86fde854d92c82283660c10ca58">00112</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>;
<a name="l00113"></a>00113     <span class="keyword">protected</span>:
<a name="l00119"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ac413284fee3eb42ef05be9a920da448b">00119</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;HardwareVertexBuffer*&gt;::type</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ac413284fee3eb42ef05be9a920da448b" title="WARNING: The following two members should place before all other members.">VertexBufferList</a>;
<a name="l00120"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a2b2a1446c08ef1bb58c47987b62d83d0">00120</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;HardwareIndexBuffer*&gt;::type</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a2b2a1446c08ef1bb58c47987b62d83d0">IndexBufferList</a>;
<a name="l00121"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a6a99117e4adc55561ec0eb36617115a4">00121</a>         <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ac413284fee3eb42ef05be9a920da448b" title="WARNING: The following two members should place before all other members.">VertexBufferList</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a6a99117e4adc55561ec0eb36617115a4">mVertexBuffers</a>;
<a name="l00122"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a458d12d5abfa8d8971a4c4c6b214f799">00122</a>         <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a2b2a1446c08ef1bb58c47987b62d83d0">IndexBufferList</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a458d12d5abfa8d8971a4c4c6b214f799">mIndexBuffers</a>;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ab3ae22ef96c13dfa02878d27d592f3bc">00125</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;VertexDeclaration*&gt;::type</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ab3ae22ef96c13dfa02878d27d592f3bc">VertexDeclarationList</a>;
<a name="l00126"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a44e20d0e3ca12fa67e5003266a87af52">00126</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1set.html">set&lt;VertexBufferBinding*&gt;::type</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a44e20d0e3ca12fa67e5003266a87af52">VertexBufferBindingList</a>;
<a name="l00127"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ab93e6c8ebe86328233d604c78f9cbb7b">00127</a>         <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ab3ae22ef96c13dfa02878d27d592f3bc">VertexDeclarationList</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ab93e6c8ebe86328233d604c78f9cbb7b">mVertexDeclarations</a>;
<a name="l00128"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a30d13bdd51fd0ffb1b2f5cc13bc15786">00128</a>         <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a44e20d0e3ca12fa67e5003266a87af52">VertexBufferBindingList</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a30d13bdd51fd0ffb1b2f5cc13bc15786">mVertexBufferBindings</a>;
<a name="l00129"></a>00129 
<a name="l00130"></a>00130         <span class="comment">// Mutexes</span>
<a name="l00131"></a>00131         <a class="code" href="OgrePrerequisites_8h.html#a2fb96ea8ad9700f804480d1d7f5d692d">OGRE_MUTEX</a>(mVertexBuffersMutex)
<a name="l00132"></a>00132         OGRE_MUTEX(mIndexBuffersMutex)
<a name="l00133"></a>00133         OGRE_MUTEX(mVertexDeclarationsMutex)
<a name="l00134"></a>00134         OGRE_MUTEX(mVertexBufferBindingsMutex)
<a name="l00135"></a>00135 
<a name="l00137"></a>00137         virtual <span class="keywordtype">void</span> destroyAllDeclarations(<span class="keywordtype">void</span>);
<a name="l00139"></a>00139         virtual <span class="keywordtype">void</span> destroyAllBindings(<span class="keywordtype">void</span>);
<a name="l00140"></a>00140 
<a name="l00142"></a>00142         virtual <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* createVertexDeclarationImpl(<span class="keywordtype">void</span>);
<a name="l00144"></a>00144         virtual <span class="keywordtype">void</span> destroyVertexDeclarationImpl(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* decl);
<a name="l00145"></a>00145 
<a name="l00147"></a>00147         virtual <a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* createVertexBufferBindingImpl(<span class="keywordtype">void</span>);
<a name="l00149"></a>00149         virtual <span class="keywordtype">void</span> destroyVertexBufferBindingImpl(<a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* binding);
<a name="l00150"></a>00150 
<a name="l00151"></a>00151     public:
<a name="l00152"></a>00152 
<a name="l00153"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a88f21df1e7ee330033812ddeba4a08fa">00153</a>         enum <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a88f21df1e7ee330033812ddeba4a08fa">BufferLicenseType</a>
<a name="l00154"></a>00154         {
<a name="l00156"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a88f21df1e7ee330033812ddeba4a08faa372ccf538e8a6022bba092d2b47f4fdb">00156</a>             <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a88f21df1e7ee330033812ddeba4a08faa372ccf538e8a6022bba092d2b47f4fdb" title="Licensee will only release buffer when it says so.">BLT_MANUAL_RELEASE</a>,
<a name="l00158"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a88f21df1e7ee330033812ddeba4a08faa994cf0191de83556e3c1e6cf30cd6acb">00158</a>             BLT_AUTOMATIC_RELEASE
<a name="l00159"></a>00159         };
<a name="l00160"></a>00160 
<a name="l00161"></a>00161     <span class="keyword">protected</span>:
<a name="l00163"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html">00163</a>         <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#af4c2f5df97e3050dd5266408be42db4b">_OgrePrivate</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html" title="Struct holding details of a license to use a temporary shared buffer.">VertexBufferLicense</a>
<a name="l00164"></a>00164         {
<a name="l00165"></a>00165         <span class="keyword">public</span>:
<a name="l00166"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html#a2f1861c5228c9f0c56471173f92ae366">00166</a>             <a class="code" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a>* <a class="code" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html#a2f1861c5228c9f0c56471173f92ae366">originalBufferPtr</a>;
<a name="l00167"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html#aacc05cfc81340bfb844a16b50ec62ce8">00167</a>             <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a88f21df1e7ee330033812ddeba4a08fa">BufferLicenseType</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html#aacc05cfc81340bfb844a16b50ec62ce8">licenseType</a>;
<a name="l00168"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html#a79241d934a960a70e5df287bc5521f2f">00168</a>             <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html#a79241d934a960a70e5df287bc5521f2f">expiredDelay</a>;
<a name="l00169"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html#a1a95ec58966b8200dba0df5b10965b5a">00169</a>             <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html#a1a95ec58966b8200dba0df5b10965b5a">buffer</a>;
<a name="l00170"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html#a4115ddd9b35a4e04ef14f616efc670e5">00170</a>             <a class="code" href="classOgre_1_1HardwareBufferLicensee.html" title="Abstract interface representing a &#39;licensee&#39; of a hardware buffer copy.">HardwareBufferLicensee</a>* <a class="code" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html#a4115ddd9b35a4e04ef14f616efc670e5">licensee</a>;
<a name="l00171"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html#a2b2257dfe47d0f60fdc06d86cec8e20c">00171</a>             <a class="code" href="classOgre_1_1HardwareBufferManagerBase_1_1VertexBufferLicense.html" title="Struct holding details of a license to use a temporary shared buffer.">VertexBufferLicense</a>(
<a name="l00172"></a>00172                 <a class="code" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a>* orig,
<a name="l00173"></a>00173                 <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a88f21df1e7ee330033812ddeba4a08fa">BufferLicenseType</a> ltype, 
<a name="l00174"></a>00174                 <span class="keywordtype">size_t</span> delay,
<a name="l00175"></a>00175                 <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> buf, 
<a name="l00176"></a>00176                 <a class="code" href="classOgre_1_1HardwareBufferLicensee.html" title="Abstract interface representing a &#39;licensee&#39; of a hardware buffer copy.">HardwareBufferLicensee</a>* lic) 
<a name="l00177"></a>00177                 : originalBufferPtr(orig)
<a name="l00178"></a>00178                 , licenseType(ltype)
<a name="l00179"></a>00179                 , expiredDelay(delay)
<a name="l00180"></a>00180                 , buffer(buf)
<a name="l00181"></a>00181                 , licensee(lic)
<a name="l00182"></a>00182             {}
<a name="l00183"></a>00183 
<a name="l00184"></a>00184         };
<a name="l00185"></a>00185 
<a name="l00187"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ab1b16f5bb965056ed416ca0d7eedb991">00187</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1multimap.html">multimap&lt;HardwareVertexBuffer*, HardwareVertexBufferSharedPtr&gt;::type</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ab1b16f5bb965056ed416ca0d7eedb991" title="Map from original buffer to temporary buffers.">FreeTemporaryVertexBufferMap</a>;
<a name="l00189"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ac5339ff98d67f523eb88f9d1b29567d9">00189</a>         <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ab1b16f5bb965056ed416ca0d7eedb991" title="Map from original buffer to temporary buffers.">FreeTemporaryVertexBufferMap</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ac5339ff98d67f523eb88f9d1b29567d9" title="Map of current available temp buffers.">mFreeTempVertexBufferMap</a>;
<a name="l00191"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ac56a99f7b4b029db20fd8b94f1e82c13">00191</a>         <span class="keyword">typedef</span> <a class="code" href="structOgre_1_1map.html">map&lt;HardwareVertexBuffer*, VertexBufferLicense&gt;::type</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ac56a99f7b4b029db20fd8b94f1e82c13" title="Map from temporary buffer to details of a license.">TemporaryVertexBufferLicenseMap</a>;
<a name="l00193"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a811086c11e14fa760b42ea958884804e">00193</a>         <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ac56a99f7b4b029db20fd8b94f1e82c13" title="Map from temporary buffer to details of a license.">TemporaryVertexBufferLicenseMap</a> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a811086c11e14fa760b42ea958884804e" title="Map of currently licensed temporary buffers.">mTempVertexBufferLicenses</a>;
<a name="l00195"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a98d9ba3a449e791f89a53d7fcf89c00a">00195</a>         <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a98d9ba3a449e791f89a53d7fcf89c00a" title="Number of frames elapsed since temporary buffers utilization was above half the available.">mUnderUsedFrameCount</a>;
<a name="l00197"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#afd420f56dc09d1e9975179e2ffe824ca">00197</a>         <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#afd420f56dc09d1e9975179e2ffe824ca" title="Number of frames to wait before free unused temporary buffers.">UNDER_USED_FRAME_THRESHOLD</a>;
<a name="l00199"></a><a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a66f8e4f014fc41a52f35f7c0b03569e0">00199</a>         <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">size_t</span> <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a66f8e4f014fc41a52f35f7c0b03569e0" title="Frame delay for BLT_AUTOMATIC_RELEASE temporary buffers.">EXPIRED_DELAY_FRAME_THRESHOLD</a>;
<a name="l00200"></a>00200         <span class="comment">// Mutexes</span>
<a name="l00201"></a>00201         <a class="code" href="OgrePrerequisites_8h.html#a2fb96ea8ad9700f804480d1d7f5d692d">OGRE_MUTEX</a>(mTempBuffersMutex)
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204         
<a name="l00205"></a>00205         virtual <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> makeBufferCopy(
<a name="l00206"></a>00206             const <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; source, 
<a name="l00207"></a>00207             <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>::Usage usage, <span class="keywordtype">bool</span> useShadowBuffer);
<a name="l00208"></a>00208 
<a name="l00209"></a>00209     public:
<a name="l00210"></a>00210         <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html" title="Base definition of a hardware buffer manager.">HardwareBufferManagerBase</a>();
<a name="l00211"></a>00211         virtual ~HardwareBufferManagerBase();
<a name="l00240"></a>00240         virtual <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> 
<a name="l00241"></a>00241             createVertexBuffer(<span class="keywordtype">size_t</span> vertexSize, <span class="keywordtype">size_t</span> numVerts, <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>::Usage usage, 
<a name="l00242"></a>00242             <span class="keywordtype">bool</span> useShadowBuffer = false) = 0;
<a name="l00259"></a>00259         virtual <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a> 
<a name="l00260"></a>00260             createIndexBuffer(<a class="code" href="classOgre_1_1HardwareIndexBuffer.html" title="Specialisation of HardwareBuffer for vertex index buffers, still abstract.">HardwareIndexBuffer</a>::IndexType itype, <span class="keywordtype">size_t</span> numIndexes, 
<a name="l00261"></a>00261             <a class="code" href="classOgre_1_1HardwareBuffer.html" title="Abstract class defining common features of hardware buffers.">HardwareBuffer</a>::Usage usage, <span class="keywordtype">bool</span> useShadowBuffer = false) = 0;
<a name="l00262"></a>00262 
<a name="l00267"></a>00267         virtual <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">RenderToVertexBufferSharedPtr</a> createRenderToVertexBuffer() = 0;
<a name="l00268"></a>00268 
<a name="l00270"></a>00270         virtual <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* createVertexDeclaration(<span class="keywordtype">void</span>);
<a name="l00272"></a>00272         virtual <span class="keywordtype">void</span> destroyVertexDeclaration(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* decl);
<a name="l00273"></a>00273 
<a name="l00275"></a>00275         virtual <a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* createVertexBufferBinding(<span class="keywordtype">void</span>);
<a name="l00277"></a>00277         virtual <span class="keywordtype">void</span> destroyVertexBufferBinding(<a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* binding);
<a name="l00278"></a>00278 
<a name="l00284"></a>00284         virtual <span class="keywordtype">void</span> registerVertexBufferSourceAndCopy(
<a name="l00285"></a>00285             const <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; sourceBuffer,
<a name="l00286"></a>00286             const <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; copy);
<a name="l00287"></a>00287 
<a name="l00304"></a>00304         virtual <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> allocateVertexBufferCopy(
<a name="l00305"></a>00305             const <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; sourceBuffer, 
<a name="l00306"></a>00306             <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a88f21df1e7ee330033812ddeba4a08fa">BufferLicenseType</a> licenseType,
<a name="l00307"></a>00307             <a class="code" href="classOgre_1_1HardwareBufferLicensee.html" title="Abstract interface representing a &#39;licensee&#39; of a hardware buffer copy.">HardwareBufferLicensee</a>* licensee,
<a name="l00308"></a>00308             <span class="keywordtype">bool</span> copyData = false);
<a name="l00309"></a>00309 
<a name="l00318"></a>00318         virtual <span class="keywordtype">void</span> releaseVertexBufferCopy(
<a name="l00319"></a>00319             const <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; bufferCopy); 
<a name="l00320"></a>00320 
<a name="l00331"></a>00331         virtual <span class="keywordtype">void</span> touchVertexBufferCopy(
<a name="l00332"></a>00332             const <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; bufferCopy);
<a name="l00333"></a>00333 
<a name="l00343"></a>00343         virtual <span class="keywordtype">void</span> _freeUnusedBufferCopies(<span class="keywordtype">void</span>);
<a name="l00344"></a>00344 
<a name="l00351"></a>00351         virtual <span class="keywordtype">void</span> _releaseBufferCopies(<span class="keywordtype">bool</span> forceFreeUnused = false);
<a name="l00352"></a>00352 
<a name="l00362"></a>00362         virtual <span class="keywordtype">void</span> _forceReleaseBufferCopies(
<a name="l00363"></a>00363             const <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; sourceBuffer);
<a name="l00364"></a>00364 
<a name="l00374"></a>00374         virtual <span class="keywordtype">void</span> _forceReleaseBufferCopies(<a class="code" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a>* sourceBuffer);
<a name="l00375"></a>00375 
<a name="l00377"></a>00377         <span class="keywordtype">void</span> _notifyVertexBufferDestroyed(<a class="code" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a>* buf);
<a name="l00379"></a>00379         <span class="keywordtype">void</span> _notifyIndexBufferDestroyed(<a class="code" href="classOgre_1_1HardwareIndexBuffer.html" title="Specialisation of HardwareBuffer for vertex index buffers, still abstract.">HardwareIndexBuffer</a>* buf);
<a name="l00380"></a>00380 
<a name="l00381"></a>00381     };
<a name="l00382"></a>00382 
<a name="l00384"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html">00384</a>     class <a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a> : public HardwareBufferManagerBase, public <a class="code" href="classOgre_1_1Singleton.html" title="Template class for creating single-instance global classes.">Singleton</a>&lt;<a class="code" href="classOgre_1_1HardwareBufferManager.html" title="Singleton wrapper for hardware buffer manager.">HardwareBufferManager</a>&gt;
<a name="l00385"></a>00385     {
<a name="l00386"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#abdb4b01e9cf06263b1bae7fbb0bb2e9e">00386</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>;
<a name="l00387"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#ac301d86fde854d92c82283660c10ca58">00387</a>         <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a>;
<a name="l00388"></a>00388     <span class="keyword">protected</span>:
<a name="l00389"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#a154ee1cdff3ec67765532601ad272cb8">00389</a>         HardwareBufferManagerBase* <a class="code" href="classOgre_1_1HardwareBufferManager.html#a154ee1cdff3ec67765532601ad272cb8">mImpl</a>;
<a name="l00390"></a>00390     <span class="keyword">public</span>:
<a name="l00391"></a>00391         HardwareBufferManager(HardwareBufferManagerBase* imp);
<a name="l00392"></a>00392         ~HardwareBufferManager();
<a name="l00393"></a>00393 
<a name="l00395"></a>00395         <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> 
<a name="l00396"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#adee7ce85fcdeefb8b97b37ece2bab8e4">00396</a>             createVertexBuffer(<span class="keywordtype">size_t</span> vertexSize, <span class="keywordtype">size_t</span> numVerts, <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, 
<a name="l00397"></a>00397             <span class="keywordtype">bool</span> useShadowBuffer = <span class="keyword">false</span>)
<a name="l00398"></a>00398         {
<a name="l00399"></a>00399             <span class="keywordflow">return</span> mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a6009815139b407d20347dd3e2262e5ad" title="Create a hardware vertex buffer.">createVertexBuffer</a>(vertexSize, numVerts, usage, useShadowBuffer);
<a name="l00400"></a>00400         }
<a name="l00402"></a>00402         <a class="code" href="classOgre_1_1HardwareIndexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareIndexBufferSharedPtr</a> 
<a name="l00403"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#a90b4266571e1852e2475a63c062623a2">00403</a>             createIndexBuffer(<a class="code" href="classOgre_1_1HardwareIndexBuffer.html#a25ba4923e015d46de162f7cc4c256326">HardwareIndexBuffer::IndexType</a> itype, <span class="keywordtype">size_t</span> numIndexes, 
<a name="l00404"></a>00404             <a class="code" href="classOgre_1_1HardwareBuffer.html#ae51f5970d879af736e4cf53e1ec46630" title="Enums describing buffer usage; not mutually exclusive.">HardwareBuffer::Usage</a> usage, <span class="keywordtype">bool</span> useShadowBuffer = <span class="keyword">false</span>)
<a name="l00405"></a>00405         {
<a name="l00406"></a>00406             <span class="keywordflow">return</span> mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ae46262b1cc1e8bfe136e9bb203894c41" title="Create a hardware index buffer.">createIndexBuffer</a>(itype, numIndexes, usage, useShadowBuffer);
<a name="l00407"></a>00407         }
<a name="l00408"></a>00408 
<a name="l00410"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#a875cea867279770d7900f292a8217db6">00410</a>         <a class="code" href="classOgre_1_1SharedPtr.html" title="Reference-counted shared pointer, used for objects where implicit destruction is required.">RenderToVertexBufferSharedPtr</a> createRenderToVertexBuffer()
<a name="l00411"></a>00411         {
<a name="l00412"></a>00412             <span class="keywordflow">return</span> mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a830cd072c0e063e729b67201f04492a1" title="Create a render to vertex buffer.">createRenderToVertexBuffer</a>();
<a name="l00413"></a>00413         }
<a name="l00414"></a>00414 
<a name="l00416"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#a0d6a29a55a89d937cec4cbaa6c7e8b4b">00416</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* createVertexDeclaration(<span class="keywordtype">void</span>)
<a name="l00417"></a>00417         {
<a name="l00418"></a>00418             <span class="keywordflow">return</span> mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#aa8203be281c1d4f66efd3e5f9616962a" title="Creates a new vertex declaration.">createVertexDeclaration</a>();
<a name="l00419"></a>00419         }
<a name="l00421"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#a8df941430aef9a6c87660655b51672a3">00421</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> destroyVertexDeclaration(<a class="code" href="classOgre_1_1VertexDeclaration.html" title="This class declares the format of a set of vertex inputs, which can be issued to the rendering API th...">VertexDeclaration</a>* decl)
<a name="l00422"></a>00422         {
<a name="l00423"></a>00423             mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a95462f68508b75a7d87d0c5e496806fa" title="Destroys a vertex declaration.">destroyVertexDeclaration</a>(decl);
<a name="l00424"></a>00424         }
<a name="l00425"></a>00425 
<a name="l00427"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#a4d907dd6ed467886ca7df6a188b73d4d">00427</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* createVertexBufferBinding(<span class="keywordtype">void</span>)
<a name="l00428"></a>00428         {
<a name="l00429"></a>00429             <span class="keywordflow">return</span> mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a061290f70a7b145768a09030ac8684bf" title="Creates a new VertexBufferBinding.">createVertexBufferBinding</a>();
<a name="l00430"></a>00430         }
<a name="l00432"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#af5abdc6a7e28634b759189e54f1e6fdd">00432</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> destroyVertexBufferBinding(<a class="code" href="classOgre_1_1VertexBufferBinding.html" title="Records the state of all the vertex buffer bindings required to provide a vertex declaration with the...">VertexBufferBinding</a>* binding)
<a name="l00433"></a>00433         {
<a name="l00434"></a>00434             mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a8f392b28a07b9f8f6b70f3020598acfe" title="Destroys a VertexBufferBinding.">destroyVertexBufferBinding</a>(binding);
<a name="l00435"></a>00435         }
<a name="l00437"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#a763b65efa057185d7acbe073bf0e3610">00437</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> registerVertexBufferSourceAndCopy(
<a name="l00438"></a>00438             <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; sourceBuffer,
<a name="l00439"></a>00439             <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; copy)
<a name="l00440"></a>00440         {
<a name="l00441"></a>00441             mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a1deff999bf2f7fa437609fca417810e9" title="Registers a vertex buffer as a copy of another.">registerVertexBufferSourceAndCopy</a>(sourceBuffer, copy);
<a name="l00442"></a>00442         }
<a name="l00444"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#a9061909fca1c96d50ddbeeee6df8a4d8">00444</a>         <span class="keyword">virtual</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a> allocateVertexBufferCopy(
<a name="l00445"></a>00445             <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; sourceBuffer, 
<a name="l00446"></a>00446             <a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a88f21df1e7ee330033812ddeba4a08fa">BufferLicenseType</a> licenseType,
<a name="l00447"></a>00447             <a class="code" href="classOgre_1_1HardwareBufferLicensee.html" title="Abstract interface representing a &#39;licensee&#39; of a hardware buffer copy.">HardwareBufferLicensee</a>* licensee,
<a name="l00448"></a>00448             <span class="keywordtype">bool</span> copyData = <span class="keyword">false</span>)
<a name="l00449"></a>00449         {
<a name="l00450"></a>00450             <span class="keywordflow">return</span> mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#aabe7d6ac6a04013f106656c76a0eb222" title="Allocates a copy of a given vertex buffer.">allocateVertexBufferCopy</a>(sourceBuffer, licenseType, licensee, copyData);
<a name="l00451"></a>00451         }
<a name="l00453"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#a34bc652b029f856a5b130f850ba333a0">00453</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> releaseVertexBufferCopy(
<a name="l00454"></a>00454             <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; bufferCopy)
<a name="l00455"></a>00455         {
<a name="l00456"></a>00456             mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#ace31f1bc14e398d1379b1e50af9f87c3" title="Manually release a vertex buffer copy for others to subsequently use.">releaseVertexBufferCopy</a>(bufferCopy);
<a name="l00457"></a>00457         }
<a name="l00458"></a>00458 
<a name="l00460"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#af83a478657dabe2d2e35f0d876abcc5b">00460</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> touchVertexBufferCopy(
<a name="l00461"></a>00461             <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; bufferCopy)
<a name="l00462"></a>00462         {
<a name="l00463"></a>00463             mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a6530263f486220aa3040129240d3caed" title="Tell engine that the vertex buffer copy intent to reuse.">touchVertexBufferCopy</a>(bufferCopy);
<a name="l00464"></a>00464         }
<a name="l00465"></a>00465 
<a name="l00467"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#a9a2793066da237001972061b76930c95">00467</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _freeUnusedBufferCopies(<span class="keywordtype">void</span>)
<a name="l00468"></a>00468         {
<a name="l00469"></a>00469             mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a33cb1e71d569f6c3b277c70bdea870c0" title="Free all unused vertex buffer copies.">_freeUnusedBufferCopies</a>();
<a name="l00470"></a>00470         }
<a name="l00472"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#a8632cd79b8f18ed2b21bd6b474a49276">00472</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _releaseBufferCopies(<span class="keywordtype">bool</span> forceFreeUnused = <span class="keyword">false</span>)
<a name="l00473"></a>00473         {
<a name="l00474"></a>00474             mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a507f064fdba0dd61a438f61a2dafac26" title="Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_REL...">_releaseBufferCopies</a>(forceFreeUnused);
<a name="l00475"></a>00475         }
<a name="l00477"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#ab523a5b31c88599812538441b7e37775">00477</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _forceReleaseBufferCopies(
<a name="l00478"></a>00478             <span class="keyword">const</span> <a class="code" href="classOgre_1_1HardwareVertexBufferSharedPtr.html" title="Shared pointer implementation used to share index buffers.">HardwareVertexBufferSharedPtr</a>&amp; sourceBuffer)
<a name="l00479"></a>00479         {
<a name="l00480"></a>00480             mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a0de1e9752a1f55aadcc839a4c1633a2f" title="Internal method that forces the release of copies of a given buffer.">_forceReleaseBufferCopies</a>(sourceBuffer);
<a name="l00481"></a>00481         }
<a name="l00483"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#a0da9a2c9a66030d32c90871191da0b6a">00483</a>         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _forceReleaseBufferCopies(<a class="code" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a>* sourceBuffer)
<a name="l00484"></a>00484         {
<a name="l00485"></a>00485             mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a0de1e9752a1f55aadcc839a4c1633a2f" title="Internal method that forces the release of copies of a given buffer.">_forceReleaseBufferCopies</a>(sourceBuffer);
<a name="l00486"></a>00486         }
<a name="l00488"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#a2b188dbba89b0210ad7359434aa87bee">00488</a>         <span class="keywordtype">void</span> _notifyVertexBufferDestroyed(<a class="code" href="classOgre_1_1HardwareVertexBuffer.html" title="Specialisation of HardwareBuffer for a vertex buffer.">HardwareVertexBuffer</a>* buf)
<a name="l00489"></a>00489         {
<a name="l00490"></a>00490             mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#a29b2e243bab8522ae27ec23268ea154a" title="Notification that a hardware vertex buffer has been destroyed.">_notifyVertexBufferDestroyed</a>(buf);
<a name="l00491"></a>00491         }
<a name="l00493"></a><a class="code" href="classOgre_1_1HardwareBufferManager.html#aee835c8225ba41a1358db813ce080b0e">00493</a>         <span class="keywordtype">void</span> _notifyIndexBufferDestroyed(<a class="code" href="classOgre_1_1HardwareIndexBuffer.html" title="Specialisation of HardwareBuffer for vertex index buffers, still abstract.">HardwareIndexBuffer</a>* buf)
<a name="l00494"></a>00494         {
<a name="l00495"></a>00495             mImpl-&gt;<a class="code" href="classOgre_1_1HardwareBufferManagerBase.html#aa12ae6a67af715b2be80182bd05abb46" title="Notification that a hardware index buffer has been destroyed.">_notifyIndexBufferDestroyed</a>(buf);
<a name="l00496"></a>00496         }
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 
<a name="l00514"></a>00514         <span class="keyword">static</span> HardwareBufferManager&amp; getSingleton(<span class="keywordtype">void</span>);
<a name="l00530"></a>00530         <span class="keyword">static</span> HardwareBufferManager* getSingletonPtr(<span class="keywordtype">void</span>);
<a name="l00531"></a>00531             
<a name="l00532"></a>00532     };
<a name="l00533"></a>00533 
<a name="l00536"></a>00536 }
<a name="l00537"></a>00537 
<a name="l00538"></a>00538 <span class="preprocessor">#endif</span>
<a name="l00539"></a>00539 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:50
</p>
</body>
</html>
